#include <fstream>
#include <cmath>
using namespace std;

// |prod vectorial| = det
int DubluArieTriunghi(int x1, int y1, int x2, int y2, int x3, int y3)
{
    return abs((x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1));
}

int main()
{
	ifstream fin("triunghi.in");
	ofstream fout("triunghi.out");
	int x1, y1, x2, y2, x3, y3;
	int n;

	fin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	fin >> n;

	int aria = DubluArieTriunghi(x1, y1, x2, y2, x3, y3);

	int nr = 0, x, y;
	for (int i = 0; i < n; ++i)
	{
		fin >> x >> y;
		if (aria == DubluArieTriunghi(x, y, x2, y2, x3, y3) +
					DubluArieTriunghi(x1, y1, x, y, x3, y3) +
					DubluArieTriunghi(x1, y1, x2, y2, x, y))
            nr++;
	}
	fout << nr;
}
